{13}
{Josef Pihera}
unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, xmldom, XMLIntf, StdCtrls, ExtCtrls, msxmldom, XMLDoc, Grids,
  ValEdit, schema, ComCtrls, ToolWin,  Types;

const rowdist = 4;

const tooldelete = 1;
      toolselect = 2;

type TNotaPos= class(TObject)
        top,left,bottom,right:Integer;
        child:Integer;
        constructor Create(_top,_left,_bottom,_right,_child:Integer);
        function asRect:TRect;
        function PtInRect(pt:TPoint):Boolean;
      end;

type
  TForm1 = class(TForm)
    XMLDocument1: TXMLDocument;
    Panel1: TPanel;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    ValueListEditor1: TValueListEditor;
    Panel2: TPanel;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    Button2: TButton;
    SaveDialog1: TSaveDialog;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    procedure Button1Click(Sender: TObject);
    procedure XMLDocument1AfterOpen(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private declarations }
    noty:TStringList;
    pomlky:TStringList;
    takty:TStringList;
    notaname:TStringList;
    klic:TBitmap;
    sch:IXMLSkladbaType;
    pic:TBitmap;
    dc:TCanvas;
    taktu:Integer;
    rozld:array[1..10] of real;
    rozldot:array[1..10] of Boolean;
    tool:Integer;
    evx,evy:Integer;
    notypos:TList;
    undo:TList;
    redo:TList;
    selst:TPoint;
    selen:TPoint;
    selecting:Boolean;
    procedure DumpNotyPos;
    procedure DumpRedo;
    procedure DumpUndo;
    procedure DrawSel;
    procedure SetTakt(takt: String);
  public
    { Public declarations }
    function CountDelka:Real;
    function GetTakt:String;
    function GetTaktLen:Integer;
    procedure Init;
    procedure Redraw;
    procedure LoadImg;
    procedure DrawOsnova;
    procedure DrawNoty;
    function DrawNota(p:Real; nota:IXMLNotaType):Real;
    function DrawPomlka(p:Real; pomlka:IXMLPomlkaType):Real;
    procedure Dot(p:Real; offset:Integer);
    function taktImg(str:String):Tbitmap;
    function getX(p:Real):Integer;
    function getY(offset:Integer):Integer;
    function RozkladCnt(p:Real; d:Real):Integer;
    procedure Rozklad(index:Integer; var pd:Real; var dot:Boolean);
    function pomlkaImg(d:Real):TBitmap;
    function notaImg(v:String; vi:Integer; d:Real):TBitmap;
    function findNota(x,y:Integer):Integer;
    procedure DeleteNota;
 end;

var
  Form1: TForm1;

implementation

uses Math;

var decimal:TFormatSettings;


{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    DumpRedo;
    DumpUndo;
    ToolButton4.Enabled:=false;
    ToolButton5.Enabled:=false;
    XMLDocument1.LoadFromFile(OpenDialog1.FileName);
  end;
end;


procedure TForm1.Redraw;
var len:Real;
begin
  DumpNotyPos;
  len:=CountDelka;
  taktu:=(Ceil(len) div GetTaktLen)+ 2;
  pic:=TBitmap.Create;
  pic.Height:=400;
  pic.Width:=100 + GetTaktLen * 50 * taktu;
  dc:=pic.Canvas;

  DrawOsnova;
  DrawNoty;

  Image1.Picture.Assign(pic);
  pic.Free;
end;

procedure TForm1.XMLDocument1AfterOpen(Sender: TObject);
var err:Boolean;
begin
  err:=false;
  try
    sch:=Getskladba(XMLDocument1);
    Redraw;
  except
   on E:Exception do
   begin
      err:=true;
      ShowMessage('Neni platny format ('+e.Message+')');
      XMLDocument1.Active:=false;
   end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Init;
  LoadImg;
  ToolButton2.Click;
  ToolButton2.Down:=true;
end;

function bmp(fn:String):TBitmap;
var prg,f:String;
    bm:TBitmap;
begin
  prg:=ExtractFilePath(ParamStr(0));
  f:=IncludeTrailingPathDelimiter(prg) + 'bmp\' + fn + '.bmp';
  bm:=TBitmap.Create;
  bm.LoadFromFile(f);
  bm.TransparentColor:=clWhite;
  bm.Transparent:=true;
  Result:=bm;
end;

procedure TForm1.LoadImg;
begin
  noty:=TStringList.Create;
  noty.AddObject('4d',bmp('nota_4'));
  noty.AddObject('4u',bmp('nota_4'));
  noty.AddObject('4uc',bmp('nota_krizek_4'));
  noty.AddObject('4dc',bmp('nota_krizek_4'));

  noty.AddObject('2d',bmp('nota_dolu_2'));
  noty.AddObject('2u',bmp('nota_nahoru_2'));
  noty.AddObject('2dc',bmp('nota_krizek_dolu_2'));
  noty.AddObject('2uc',bmp('nota_krizek_nahoru_2'));

  noty.AddObject('1d',bmp('nota_dolu_1'));
  noty.AddObject('1u',bmp('nota_nahoru_1'));
  noty.AddObject('1dc',bmp('nota_krizek_dolu_1'));
  noty.AddObject('1uc',bmp('nota_krizek_nahoru_1'));

  noty.AddObject('0d',bmp('nota_dolu_0'));
  noty.AddObject('0u',bmp('nota_nahoru_0'));
  noty.AddObject('0dc',bmp('nota_krizek_dolu_0'));
  noty.AddObject('0uc',bmp('nota_krizek_nahoru_0'));

  pomlky:=TStringList.Create;
  pomlky.AddObject('4',bmp('pomlka_4'));
  pomlky.AddObject('2',bmp('pomlka_2'));
  pomlky.AddObject('1',bmp('pomlka_1'));
  pomlky.AddObject('0',bmp('pomlka_0'));

  klic:=bmp('klic');

  takty:=TStringList.Create;
  takty.AddObject('3/4',bmp('takt_3'));
  takty.AddObject('4/4',bmp('takt_4'));
  takty.AddObject('5/4',bmp('takt_5'));
end;

procedure TForm1.Init;
begin
  notypos:=TList.Create;
  undo:=TList.Create;
  redo:=TList.Create;
end;

function TForm1.CountDelka: Real;
var d,cl:Real;
    i:Integer;
    l:String;
begin
  d:=0;
  for i:=0 to sch.ChildNodes.Count-1 do
  begin
    if (sch.ChildNodes[i].NodeName = 'nota') or (sch.ChildNodes[i].NodeName='pomlka') then
     begin
       l:=sch.ChildNodes[i].Attributes['delka'];
       cl:=StrToFloat(l,decimal);
       d:=d+cl;
     end;
  end;
  Result:=d;
end;

function TForm1.GetTakt: String;
begin
  Result:=sch.Takt;
  if (Result<>'3/4') and (Result<>'4/4') and (Result<>'5/4') then
   begin
     raise Exception.Create('Spatny takt');
   end;
end;

function TForm1.GetTaktLen: Integer;
var t:String;
begin
  t:=GetTakt;
  Result:=4;
  if t='3/4' then Result:=3;
  if t='5/4' then Result:=5;
end;

procedure TForm1.DrawOsnova;
var i,e,tlen:Integer;
begin
  e:=pic.Width;
  for i:=-2 to 14 do
  if i mod 2 =0 then
  begin
    if (i>=2) and (i<=10) then
     dc.Pen.Color:=clBlack else dc.Pen.Color:=RGB(240,240,240);
    dc.MoveTo(0, 300-i*rowdist);
    dc.LineTo(e, 300-i*rowdist);
  end;
  dc.Draw(0,300-4*rowdist-32,klic);
  dc.Draw(50,300-9*rowdist,taktImg(GetTakt));
  dc.Pen.Color:=clBlack;
  tlen:=GetTaktLen;
  for i:=1 to taktu do
  begin
    dc.MoveTo(100+50*tlen*i-10,300-10*rowdist);
    dc.LineTo(100+50*tlen*i-10, 300-2*rowdist);
  end;
end;

function TForm1.taktImg(str: String): Tbitmap;
begin
  Result:=takty.Objects[takty.IndexOf(str)] as TBitmap;
end;

procedure TForm1.DrawNoty;
var pos:Real;
    i:Integer;
    node:IXMLNode;
begin
  pos:=0;
  for i:=0 to sch.ChildNodes.Count-1 do
  begin
    node:=sch.ChildNodes[i];
    if node.NodeName='nota' then
    begin
      pos:=pos+DrawNota(pos,node as IXMLNotaType);
      TNotaPos(notypos[notypos.Count-1]).child:=i;
    end else
    begin
      pos:=pos+DrawPomlka(pos,node as IXMLPomlkaType);
      TNotaPos(notypos[notypos.Count-1]).child:=i;
    end;
  end;
end;

function TForm1.DrawNota(p: Real; nota: IXMLNotaType): Real;

 function notaY(v:Integer; _is:Boolean; pd:Real):Integer;
 begin
   Result:=GetY(v);
   if (v<=6) and (pd<4) then
    Result:=Result-21 else
   begin
     Result:=Result-rowdist;
   end;
   if _is then
    if (v>6) or (pd=4) then
      Result:=Result-rowdist;
 end;

var d,norm,mp,maxp:Real;
    c,i,y,ind,mx:Integer;
    pd,prevp:Real;
    dot:Boolean;
    vyska:Integer;
    np:TNotaPos;
begin
  d:=StrToFloat(nota.Delka,decimal);
  mp:=p;
  c:=RozkladCnt(p,d);
  ind:=0;
  while ValueListEditor1.Strings.Names[ind]<>nota.Vyska do inc(ind);
  vyska:=StrToInt(ValueListEditor1.Strings.ValueFromIndex[ind]);
  prevp:=-1;
  maxp:=p;
  for i:=1 to c do
  begin
    if mp>maxp then maxp:=mp;
    Rozklad(i,pd,dot);
    y:=notaY(vyska, Pos('is',nota.Vyska)>0,pd);
    dc.Draw(GetX(mp),y,notaImg(nota.Vyska,vyska,pd));
    if dot then Self.Dot(mp,vyska);

    if prevp<>-1 then {TODO: Obloucek}
    begin
      mx:=(GetX(prevp)+GetX(mp)) div 2;
      if vyska>6 then
      begin
        dc.MoveTo(GetX(prevp), getY(vyska) -4);
        dc.LineTo(mx, getY(vyska) -6);
        dc.MoveTo(mx, getY(vyska) -6);
        dc.LineTo(GetX(mp), getY(vyska) -4);
      end else
      begin
        dc.MoveTo(GetX(prevp), getY(vyska) +4);
        dc.LineTo(mx, getY(vyska) +6);
        dc.MoveTo(mx, getY(vyska) +6);
        dc.LineTo(GetX(mp), getY(vyska) +4);
      end;
    end;

    prevp:=mp;

    if dot then
     mp:=mp+pd*0.5;
    mp:=mp+pd;
  end;
  Result:=d;
  np:=TNotaPos.Create(GetY(vyska)-rowdist,GetX(p)-5,GetY(vyska)+rowdist,GetX(maxp)+25,0);
  notypos.Add(np);
end;

function TForm1.DrawPomlka(p: Real; pomlka: IXMLPomlkaType): Real;

 function pomlkaOff(d:Real):Integer;
 begin
   Result:=7;
   if d=0.5 then Result:=7;
   if d=1 then Result:=8;
   if d=2 then Result:=7;
   if d=4 then Result:=8;
 end;

var d,norm,mp,maxp:Real;
    c,i:Integer;
    pd:Real;
    dot:Boolean;
    np:TNotaPos;
begin
  d:=StrToFloat(pomlka.Delka,decimal);
  mp:=p;
  c:=RozkladCnt(p,d);
  maxp:=p;
  for i:=1 to c do
  begin
    if mp>maxp then maxp:=mp;
    Rozklad(i,pd,dot);
    dc.Draw(GetX(mp),getY(pomlkaOff(pd)),pomlkaImg(pd));
    if dot then
     Self.Dot(mp,pomlkaOff(pd));
    mp:=mp+pd;
    if dot then
     mp:=mp+pd*0.5;
  end;
  Result:=d;
  np:=TNotaPos.Create(GetY(8)-rowdist,GetX(p)-5,GetY(7)+rowdist,GetX(maxp)+25,0);
  notypos.Add(np);
end;

procedure TForm1.Dot(p: Real; offset: Integer);
begin
  dc.Pen.Color:=clBlack;
  dc.Brush.Color:=clBlack;
  dc.Ellipse(getX(p)+20,getY(offset)-2,getX(p)+24,getY(offset)+2);
end;

function TForm1.getX(p: Real): Integer;
begin
  Result:=100+round(p*50);
end;

function TForm1.getY(offset: Integer): Integer;
begin
  Result:=300-offset*rowdist;
end;

procedure TForm1.Rozklad(index: Integer; var pd: Real;
  var dot: Boolean);
begin
  pd:=rozld[index];
  dot:=rozldot[index];
end;

function TForm1.RozkladCnt(p, d: Real): Integer;
var r,rem,k,klen:Real;
    pup,pupt:Integer;
    tlen:Integer;
    cnt:Integer;
    dot:Boolean;
begin
  tlen:=GetTaktLen;
  pup:=Floor(p);
  pupt:=pup div tlen;
  if pupt * tlen =p then
  begin
    r:=tlen;
  end else
  begin
    r:=(pupt+1)*tlen - p;
  end;
  cnt:=0;
  rem:=d;
  while rem>0 do
  begin
    dot:=false;
    k:=0.5;
    while (k*2<=r) and (k*2<=rem) do k:=k*2;
    if (k*1.5<=r) and (k*1.5<=rem) then
    begin
      klen:=k*1.5;
      dot:=true;
    end else
    begin
      klen:=k;
    end;
    r:=r-klen;
    rem:=rem-klen;
    inc(cnt);
    rozld[cnt]:=k;
    rozldot[cnt]:=dot;
    if r=0 then r:=tlen;
  end;
  Result:=cnt;
end;

function TForm1.pomlkaImg(d: Real): TBitmap;
var di:Integer;
begin
  di:=Round(d);
  Result:=pomlky.Objects[pomlky.IndexOf(IntToStr(di))] as TBitmap;
end;

function TForm1.notaImg(v: String; vi:Integer; d: Real): TBitmap;
var
    dir:char;
    cr:String;
    doba:String;
begin
  cr:='';
  dir:='u';
  if vi>6 then dir:='d';
  doba:=IntToStr(Floor(d));
  if pos('is',v)>0 then cr:='c';
  Result:=noty.Objects[noty.indexOf(doba+dir+cr)] as TBitmap;
end;

procedure TForm1.ToolButton1Click(Sender: TObject);
begin
  Tool:=tooldelete;
  Image1.Cursor:=crCross;
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
  case tool of
    tooldelete: DeleteNota;
  end;
end;

procedure TForm1.DeleteNota;
var i:Integer;
    sl:TStringList;
begin
  i:=findNota(evx,evy);
  if i<>-1 then
  begin
    DumpRedo;
    if undo.Count>30 then
    begin
      TStringList(undo[0]).Free;
      undo.Delete(0);
    end;
    sl:=TStringList.Create;
    sl.Text:=XMLDocument1.XML.Text;
    undo.Add(sl);
    ToolButton4.Enabled:=true;
    sch.ChildNodes.Delete(TNotaPos(notypos[i]).child);
    Redraw;
  end;
end;

{ TNotaPos }

function TNotaPos.asRect: TRect;
begin
  result:=Rect(left,top,bottom,right);
end;

constructor TNotaPos.Create(_top, _left, _bottom, _right,_child:Integer);
begin
  self.top:=_top;
  self.left:=_left;
  self.bottom:=_bottom;
  self.right:=_right;
  self.child:=_child;
end;

function TNotaPos.PtInRect(pt: TPoint): Boolean;
begin
  Result:=
    (pt.x>=left) and (pt.x<=right) and (pt.y>=top) and (pt.y<=bottom);
end;

function TForm1.findNota(x, y: Integer): Integer;
var i:Integer;
begin
  Result:=-1;
  for i:=0 to notypos.Count-1 do
  begin
    if TNotaPos(notypos.Items[i]).PtInRect(Point(x,y)) then
     begin
       Result:=i;
       break;
     end;
  end;
end;

procedure TForm1.DumpNotyPos;
var i:Integer;
begin
  for i:=0 to notypos.Count-1 do
   TNotaPos(notypos[i]).Free;
  notypos.Clear;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if SaveDialog1.Execute then
  begin
    XMLDocument1.SaveToFile(SaveDialog1.FileName);
  end;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  evx:=X;
  evy:=Y;
  case tool of
    toolselect:
    if selecting then
     begin
       DrawSel;
       selen:=Point(x,y);
       DrawSEl;
     end;
  end;
end;

procedure TForm1.ToolButton2Click(Sender: TObject);
begin
  Image1.Cursor:=crDefault;
  tool:=0;

end;

procedure TForm1.ToolButton4Click(Sender: TObject);
var sl,sl2:TSTringList;
begin
  if undo.Count>0 then
  begin
    sl:=TStringList(undo[undo.Count-1]);
    undo.Delete(undo.Count-1);
    ToolButton4.Enabled:=undo.Count>0;
    sl2:=TStringList.Create;
    sl2.Text:=XMLDocument1.XML.Text;
    redo.Add(sl2);
    ToolButton5.Enabled:=true;
    XMLDocument1.XML.Text:=sl.Text;
    XMLDocument1.Active:=true;
    sl.Free;
  end;
end;

procedure TForm1.ToolButton5Click(Sender: TObject);
var sl,sl2:TSTringList;
begin
  if redo.Count>0 then
  begin
    sl:=TStringList(redo[redo.Count-1]);
    redo.Delete(redo.Count-1);
    ToolButton5.Enabled:=redo.Count>0;
    sl2:=TStringList.Create;
    sl2.Text:=XMLDocument1.XML.Text;
    undo.Add(sl2);
    ToolButton4.Enabled:=true;
    XMLDocument1.XML.Text:=sl.Text;
    XMLDocument1.Active:=true;
    sl.Free;
  end;
end;

procedure TForm1.DumpRedo;
var i:Integer;
begin
  for i:=0 to redo.Count-1 do
   TStringList(redo[i]).Free;
  redo.Clear;
end;

procedure TForm1.DumpUndo;
var i:Integer;
begin
  for i:=0 to undo.Count-1 do
   TStringList(undo[i]).Free;
  undo.Clear;
end;

procedure TForm1.ToolButton6Click(Sender: TObject);
begin
  tool:=toolselect;
  selecting:=false;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  case tool of
    toolselect:
     begin
       selst:=Point(X,Y);
       selen:=Point(X,Y);
       selecting:=true;
       DrawSel;
     end;
  end;
end;

procedure TForm1.DrawSel;
begin
  Image1.Canvas.DrawFocusRect(Rect(selst.x,selst.y,selen.X,selen.Y));
end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  selecting:=false;
  {TODO: Processing selection}
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  SetTakt('3/4');
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  SetTakt('4/4');
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  SetTakt('5/4');
end;

procedure TForm1.SetTakt(takt:STring);
begin
  if not XMLDocument1.Active then
  begin
    ShowMessage('Tohle zatime umime jen kdyz je otevren nejaky dokument... Otevrete neco.');
  end else
  begin
    sch.Takt:=takt;
    Redraw;
  end;
end;

procedure TForm1.Button6Click(Sender: TObject);
var i,j:Integer;
    n:IXMLNotaType;
begin
   if not XMLDocument1.Active then
   begin
     ShowMessage('Nejdriv je treba mit neco otevrene');
   end;
   for i:=0 to sch.ChildNodes.Count-1 do
   begin
     if sch.ChildNodes[i].NodeName='nota' then
     begin
       n:=sch.ChildNodes[i] as IXMLNotaType;
       j:=0;
       while ValueListEditor1.Strings.Names[j]<>n.Vyska do inc(j);
       if j<ValueListEditor1.Strings.Count-1 then
         n.Vyska:=ValueListEditor1.Strings.Names[j+1];
     end;
   end;
   Redraw;
end;

initialization
  GetLocaleFormatSettings(0,decimal);
  decimal.DecimalSeparator:='.';
finalization
end.
